var Global_DP_SlotMachine = {
    dir: 'res/game/slot_machine/',
    layer: null,
    machine: null,
    img_u: [null, null, null],
    img_d: [null, null, null],
    coin_box: null,
    delta_speed: 100,
    result: [null, null, null],
    tip_arrow_curve: null
};

function setSlotMachineResult() {
    var all = [0, 1, 2, 3, 4, 5, 6];
    var same_rate = Math.random() * 5;
    var coin_number = zGetLocalCoinNumber();
    // zLog('coin_number : ', coin_number, ', same_rate : ', same_rate.toFixed(2));
    if ((coin_number > 500 && same_rate < 1) || (coin_number <= 500 && same_rate < 2)) {
        // zLog('same !!! ');
        var result = Math.floor(Math.random() * all.length);
        Global_DP_SlotMachine.result[0] = result;
        Global_DP_SlotMachine.result[1] = result;
        Global_DP_SlotMachine.result[2] = result;
    } else {
        // zLog('not same !!! ');
        var result0 = all.splice(Math.floor(Math.random() * all.length), 1);
        var result1 = all[Math.floor(Math.random() * all.length)];
        var result2 = all[Math.floor(Math.random() * all.length)];
        Global_DP_SlotMachine.result[0] = result0;
        Global_DP_SlotMachine.result[1] = result1;
        Global_DP_SlotMachine.result[2] = result2;
    }
}

// 成对的图 一上一下 轮流往下移动 移动到底之后回到上面继续往下移动
var Global_DP_SlotMachine_ImagePair = cc.Node.extend({
    speed: null,
    curSpeed: null,
    time: 0,
    u: null,
    d: null,
    len: null,
    idx: null,
    ctor: function (len, idx) {
        this._super();
        this.len = len;
        this.idx = idx;

        this.img_d = new cc.Sprite();
        this.img_u = new cc.Sprite();
        this.addChild(this.img_d);
        this.addChild(this.img_u);
    },
    setUD: function () {
        this.u = [];
        this.d = [];
        for (var i = 0; i < this.len; ++i) {
            this.u.push(Math.floor(Math.random() * 7));
            this.d.push(Math.floor(Math.random() * 7));
        }
        this.u.pop();
        this.u.push(Global_DP_SlotMachine.result[this.idx]);
        this.speed = this.u.length * Global_DP_SlotMachine.delta_speed;
        // zLog('u : ', this.u[this.u.length - 1], ', d : ', this.d[this.d.length - 1]);
    },
    setImageDown: function () {
        var name = 'img_' + this.d.shift();
        zSetSpriteTexture(Global_DP_SlotMachine.dir, name, this.img_d);
        this.img_d.setName(name);
    },
    setImageUp: function () {
        var name = 'img_' + this.u.shift();
        zSetSpriteTexture(Global_DP_SlotMachine.dir, name, this.img_u);
        this.img_u.setName(name);
    },
    setImagePosDown: function (pos) {
        this.img_d.setPosition(pos);
        this.posDown = pos;
    },
    setImagePosUp: function (pos) {
        this.img_u.setPosition(pos);
    },
    resetImage: function () {
        this.setImageDown();
        this.setImageUp();
        this.setImagePosDown(this.posDown);
    },
    roll: function () {
        // 初始当前速度和时间
        this.curSpeed = this.speed;
        this.time = 0;
        this.scheduleUpdate();
        this.rollUp();
        this.rollDown();

        // this.t1 = new Date();
    },
    rollDown: function () {
        this.time++;
        // this.curSpeed -= this.time * this.time;
        this.curSpeed -= Global_DP_SlotMachine.delta_speed;
        // zLog('speed : ', this.curSpeed.toFixed(2));
        if (this.curSpeed <= 0) {
            // zLog('  d: ', this.img_u.y.toFixed(2));
            return;
        }
        this.img_d.setPosition(0, this.img_u.y + this.img_u.height + 100);
        this.img_d.runAction(cc.sequence(
            cc.moveTo((this.img_d.y + 215 / 2 + this.img_d.height / 2 + 50) / this.curSpeed, 0, -(215 / 2 + this.img_d.height / 2 + 50)),
            cc.callFunc(function () {
                this.setImageDown();
                this.rollDown();
            }.bind(this))
        ));
    },
    rollUp: function () {
        if (this.curSpeed <= 0) {
            // zLog('u: ', this.img_u.y.toFixed(2));
            return;
        }
        this.img_u.setPosition(0, this.img_d.y + this.img_d.height + 100);
        this.img_u.runAction(cc.sequence(
            cc.moveTo((this.img_u.y + 215 / 2 + this.img_d.height / 2) / this.curSpeed, 0, -(215 / 2 + this.img_u.height / 2)),
            cc.callFunc(function () {
                this.setImageUp();
                this.rollUp();
            }.bind(this))
        ));
    },
    update: function () {
        if (this.curSpeed <= 0 && this.img_u.y <= 0) {
            this.img_u.stopAllActions();
            this.img_u.setPosition(0, 0);
            ddSound.playEffect('game_slot_machine_stop');
            /*this.t2 = new Date();
            zLog('----  dt : ', (this.t2 - this.t1) / 1000);*/
            Global_DP_SlotMachine.img_u[this.idx] = this.img_u.getName();
            // zLog('img_u : ', Global_DP_SlotMachine.img_u);
            this.unscheduleUpdate();
            // 3个列表都停止时
            var img_0 = Global_DP_SlotMachine.img_u[0];
            var img_1 = Global_DP_SlotMachine.img_u[1];
            var img_2 = Global_DP_SlotMachine.img_u[2];
            if (img_0 && img_1 && img_2) {
                // zLog('img_u : ', Global_DP_SlotMachine.img_u);
                var machine = Global_DP_SlotMachine.machine;
                var coin_box = Global_DP_SlotMachine.coin_box;
                // 进行奖励
                var p1 = cc.pAdd(zGetNodePosition(coin_box, zGetWorldPosition(machine)), cc.p(0, 0));
                var time = 1;
                if (img_0 == img_1 && img_1 == img_2) {
                    // 3个全相同
                    // zLog('same : 3');
                    coin_box.runGetCoinAction2(p1, 10);
                    // coin_box.setCoinNumber(coin_box.getCoinNumber() + 10);
                    machine.addCoinBag(10);
                    time += 1;
                } else if (img_0 == img_1 || img_1 == img_2 || img_2 == img_0) {
                    // 只有两个相同
                    // zLog('same : 2');
                    coin_box.runGetCoinAction2(p1, 5);
                    // coin_box.setCoinNumber(coin_box.getCoinNumber() + 5);
                    machine.addCoinBag(5);
                    time += 0.5;
                } else {
                    // 3个全不同
                    // zLog('same : 1');
                    // coin_box.setCoinNumber(coin_box.getCoinNumber() + 10);
                }
                // zSetLocalCoinNumber(coin_box.getCoinNumber());
                // zLog('\nRewards\n');


                Global_DP_SlotMachine.img_u = [null, null, null];
                this.scheduleOnce(function () {
                    // if (machine.hp_heart.length > 0) {
                    if (machine.hp_hearts.length > 0) {
                        setSlotMachineResult();
                        for (var i = 0; i < machine.img_pairs.length; ++i) {
                            machine.img_pairs[i].setUD();
                            machine.img_pairs[i].resetImage();
                        }
                        machine.resetHandle();
                    } else {
                        // zLog('hp_heart use up');
                        umengEvent('GAME_SRC_DONE', 'slot_machine');
                        cc.director.popScene();
                    }
                }, time);
            }
        }
    }
});

var Global_DP_SlotMachine_Machine = cc.Node.extend({
    isHandleOn: false,
    ctor: function () {
        this._super();
        Global_DP_SlotMachine.machine = this;

        var base = zNewSpriteCreate(Global_DP_SlotMachine.dir, 'machine_base', this);
        this.addImageBox();
        this.addImagePair();
        this.addHandle();
        this.addHPHeart();

        // this.addCoinBag(10);
    },
    addImageBox: function () {
        this.img_box = [];
        for (var i = 0; i < 3; ++i) {
            var img_box = zNewSpriteCreate(Global_DP_SlotMachine.dir, 'img_box', this);
            img_box.setPosition((i - 1) * (img_box.width + 10) - 8, 14.45);
            this.img_box.push(img_box);
            // zAddTouchLogPosEvent(img_box);
        }
    },
    addImagePair: function () {
        var img_pairs = [];
        var cnt = 3;
        setSlotMachineResult();
        for (var i = 0; i < cnt; ++i) {
            var img_mask = new cc.ClippingNode();
            var img_pair = new Global_DP_SlotMachine_ImagePair(20 - 5 * i + 10, i);
            this.addChild(img_mask);
            img_mask.addChild(img_pair);
            img_mask.setInverted(false);
            img_mask.setAlphaThreshold(0.5);
            img_mask.setStencil(new cc.Sprite(zGetFullPathPNG(Global_DP_SlotMachine.dir, 'img_box')));
            img_mask.setPosition(this.img_box[i].getPosition());
            img_pair.setUD();
            img_pair.setImageDown();
            img_pair.setImageUp();
            img_pair.setImagePosDown(cc.p(0, -this.img_box[i].height));
            // img_pair.roll();
            // zShowContentSize(img_pair);
            img_pairs.push(img_pair);
        }
        this.img_pairs = img_pairs;

    },
    addHandle: function () {
        var handle = zNewSpriteCreate(Global_DP_SlotMachine.dir, 'machine_handle', this);
        handle.setAnchorPoint(0, 0.5);
        handle.setPosition(307.70, 15.57);
        handle.setLocalZOrder(-1);
        var listener = zNewEventListenerCreate(function (touch, target) {
            var tip_arrow_curve = Global_DP_SlotMachine.tip_arrow_curve;
            tip_arrow_curve.stopTipAction();
        }, function (touch, target) {
            if (touch.getDelta().y < 0) {
                var tip_arrow_curve = Global_DP_SlotMachine.tip_arrow_curve;
                zPauseTargetEvent(target);
                ddSound.playEffect('turn_handle');
                tip_arrow_curve.stopTipAction();
                target.runAction(cc.sequence(
                    cc.rotateTo(0.2, 45),
                    cc.callFunc(() => {
                        var machine = Global_DP_SlotMachine.machine;
                        machine.reduceHPHeart();
                        machine.img_pairs[0].roll();
                        machine.img_pairs[1].roll();
                        machine.img_pairs[2].roll();
                        ddSound.playEffect('game_slot_machine_working8');
                    })
                ));
            }
        }, null, null);
        zSetNodeEvent(listener, handle);
        // zAddTouchLogPosEvent(handle);
        this.handle = handle;
    },
    addCoinBag: function (number) {
        var coin_bag = zNewSpriteCreate(Global_DP_SlotMachine.dir, 'reward_coin_bag', this);
        var label = zNewLabelCreate(number, null, 50, coin_bag);
        label.setPosition(coin_bag.width / 2, coin_bag.height / 2);
        label.setPosition(70.00, 53.91);
        coin_bag.setPosition(0, -100);
        coin_bag.setLocalZOrder(5);
        coin_bag.scheduleOnce(function () {
            coin_bag.removeFromParent(true);
        }, 0.2 * number);

        zAddTouchLogPosEvent(label);
    },
    resetHandle: function () {
        this.handle.setRotation(0);
        zResumeTargetEvent(this.handle);
    },
    addHPHeart: function () {
        // this.hp_heart = [];
        var hp_hearts = [];
        var hp_heart_spines = [];
        for (var i = 0; i < 5; ++i) {
            var hp_heart = zNewSpriteCreate(Global_DP_SlotMachine.dir, 'hp_heart', this);
            hp_heart.setVisible(true);
            hp_heart.setPosition(-224.54 + i * (222.84 + 224.54) / 4, 204.24);
            hp_hearts.push(hp_heart);
            // this.hp_heart.push(hp_heart);
            // zAddTouchLogPosEvent(hp_heart);

            var hp_heart_spine = zNewSpineAnimationCreate(Global_DP_SlotMachine.dir + 'spine/', 'skeleton', this);
            hp_heart_spine.setPosition(-224.54 + i * (222.84 + 224.54) / 4, 204.24);
            hp_heart_spines.push(hp_heart_spine);
        }
        this.hp_hearts = hp_hearts;
        this.hp_heart_spines = hp_heart_spines;
    },
    reduceHPHeart: function () {
        var hp_hearts = this.hp_hearts;
        if (hp_hearts.length > 0) {
            hp_hearts.pop().removeFromParent(true);
        }

        var hp_heart_spines = this.hp_heart_spines;
        // zLog('len : ', hp_heart_spines.length);
        if (hp_heart_spines.length > 0) {
            hp_heart_spine = hp_heart_spines.pop();
            hp_heart_spine.setAnimation(0, 'xinbaozha', false);
            hp_heart_spine.setCompleteListener((trackEntry) => {
                var name = trackEntry.animation ? trackEntry.animation.name : '';
                if (name == 'xinbaozha') {
                    hp_heart_spine.runAction(cc.removeSelf(true));
                }
            })
        }

        return hp_heart_spines.length;
    }
});

var DP_SlotMachineLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        this.x = cc.winSize.width / 2;
        this.y = Global_DP.sinkY;
        Global_DP_SlotMachine.layer = this;

        var bg_hd = zNewSpriteCreate(Global_DP_SlotMachine.dir, 'bg_hd', this);
        bg_hd.setAnchorPoint(0.5, 0);

        this.addMachine();
        this.addCoinBox();
        this.addTipArrowCurve();

        zAddBackButtonBegin(this);
    },
    onEnter: function () {
        var self = this;
        this._super();
        // zPauseTargetEvent(this, true);
        // this.countDown = function () {
        //     zResumeTargetEvent(this, true);
        //     var coin_box = Global_DP_SlotMachine.coin_box;
        //     coin_box.setCoinNumber(zGetLocalCoinNumber());
        // };
        // zAddInsertCoinsLayer(this, this.countDown);

        this.scheduleOnce(() => {
            ddSound.stopAll();
            ddSound.playEffect('turn_on_the_handle');
        }, 1);
        var tip_arrow_curve = Global_DP_SlotMachine.tip_arrow_curve;
        tip_arrow_curve.autoTipAction(cc.p(cc.winSize.width / 4, cc.winSize.height / 2));
    },
    addMachine: function () {
        this.machine = new Global_DP_SlotMachine_Machine();
        this.machine.setPosition(0, cc.winSize.height / 2);
        this.addChild(this.machine);
    },
    addCoinBox: function () {
        coin_box = zAddCoinBox(this);
        coin_box.addScore = function (score) {
            coin_box.setCoinNumber(coin_box.getCoinNumber() + score);
        };
        Global_DP_SlotMachine.coin_box = coin_box;
    },
    addTipArrowCurve: function () {
        var tip_arrow_curve = zAddTipArrowCurve(this);
        Global_DP_SlotMachine.tip_arrow_curve = tip_arrow_curve;
        // zLog('tip_arrow_curve : ', tip_arrow_curve);
    }
});

var DP_SlotMachineScene = cc.Scene.extend({
    ctor: function (coin_lack) {
        this._super();

        var layer = new DP_SlotMachineLayer();
        this.addChild(layer);

        if (coin_lack == true) {
            var coin_lack_layer = new cc.LayerColor(cc.color(0, 0, 0, 125));
        }

        zAddKeyboardBackEventCreate(this);
    }
});