var isRequestPermission = false;
var Global_DP_Home = {
    dir: 'res/home/'
};

var DP_HomeLayer = cc.Node.extend({
    ctor: function () {
        this._super();
        this.x = cc.winSize.width / 2;

        this.addBG();
        this.addBtn();

        // var cb_key_press = () => {
        //     cc.director.end();
        // };
        // zAddKeyboardEventCreate(cb_key_press, null, this);

        ddSound.playMusic('bgm');

        if (!isRequestPermission) {
            requestPermission();
            isRequestPermission = true;
        }
    },
    onEnter: function () {
        this._super();

        // ddSound.stopAll();
        ddSound.playEffect('home_title');
        // zResumeTargetEvent(this.btn_game);
        // zResumeTargetEvent(this.btn_short_video);
        // zResumeTargetEvent(this.btn_video);
        this.btn.forEach((item) => {
            // zLog('evt : ', item.evt);
            zResumeTargetEvent(item);
        });

        showAdBanner(true, 0.3, 0);
        addPrivacyPolicyButton(this, 'res/button/back.png');
        addFeedBackButton(this);

    },
    addBG: function () {
        var dir = Global_DP_Home.dir;
        var bg_hd = zNewSpriteCreate(dir, 'bg_hd', this);
        // var title = zNewSpriteCreate(dir, 'title', this);
        var title = zNewSpineAnimationCreate(dir + 'spine/', 'skeleton', this);

        bg_hd.setAnchorPoint(0.5, 0);
        title.setPosition(0, cc.winSize.height * 45 / 100);
        title.setAnimation(0, 'zi', true);
    },
    addBtn: function () {
        this.btn = [];
        var dir = Global_DP_Home.dir;
        var size = cc.winSize;
        var dx = 250;
        var evt = ['game', 'short_video', 'video'];
        var callBack = function (touch, target) {
            if (target.evt == 'game') {
                // zLog('btn_game');
                zPauseTargetEvent(target);
                cc.director.pushScene(new DP_GameEntryScene());
            } else if (target.evt == 'video') {
                // zLog('btn_video');
                playVideo();
            } else if (target.evt == 'short_video') {
                cc.log('short_video');
                openShortVideoActivity();
            }
        };
        for (let i = 0; i < evt.length; i++) {
            var btn = zAddButtonBegin(this, dir, 'btn_' + evt[i], callBack);
            btn.evt = evt[i];
            btn.setPosition((i - 1) * dx, size.height + 200);
            // zLog('x : ', btn.x, ', y : ', size.height / 3 - 30);
            btn.runAction(cc.sequence(
                cc.delayTime(0.5 * i),
                cc.moveTo(0.5, btn.x, size.height / 3 - 30).easing(cc.easeIn(2)),
                cc.sequence(
                    cc.delayTime(1.5 + 0.5 * i),
                    cc.scaleTo(0.2, 1.2).easing(cc.easeIn(2)),
                    cc.scaleTo(0.2, 0.9).easing(cc.easeOut(2)),
                    cc.scaleTo(0.2, 1.1).easing(cc.easeIn(2)),
                    cc.scaleTo(0.2, 1).easing(cc.easeOut(2)),
                    cc.delayTime(2.5 - 0.5 * i)
                ).repeat(655350)
            ));
            this.btn.push(btn);
        }
    }
});

var DP_HomeScene = cc.Scene.extend({
    ctor: function () {
        this._super();

        if (!zGetLocalCoinNumber()) {
            zSetLocalCoinNumber(50);
        }

        init_Global_DP();

        var layer = new DP_HomeLayer();
        this.addChild(layer);

        zGetAdConfig(layer);
        zAddKeyboardHomeBackListener(layer);
    }
});